function init(hero) {
    hero.setName("Captain Kaisa");
    hero.setTier(9);

    hero.setHelmet("item.superhero_armor.piece.head");
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");

    hero.addPowers("smp:cosmic_energy_manipulation");
    hero.addAttribute("PUNCH_DAMAGE", 9.5, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);
    hero.addAttribute("JUMP_HEIGHT", 1.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 16.0, 0);

    hero.addKeyBind("AIM", "Cosmic Energy Blast", 1);
    hero.addKeyBind("CHARGED_BEAM", "Cosmic Energy Beam", 2);
    hero.addKeyBind("BINARY_MODE", "Toggle Binary Mode", 5);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setTierOverride(getTierOverride);
    hero.supplyFunction("canAim", canAim);

    hero.setAttributeProfile(entity => entity.getData("fiskheroes:dyn/steeled") ? "BINARY" : null);
    hero.addAttributeProfile("BINARY", profile => {
        profile.inheritDefaults();
        profile.addAttribute("PUNCH_DAMAGE", 12.0, 0);
        profile.addAttribute("SPRINT_SPEED", 0.4, 1);
        profile.addAttribute("FALL_RESISTANCE", 1.0, 1);
    });

    hero.setDamageProfile(entity => entity.getData("fiskheroes:dyn/steeled") ? "BINARY" : null);
    hero.addDamageProfile("BINARY", {
        "types": {
            "BLUNT": 1.0,
            "ENERGY": 0.7,
            "COSMIC": 1.0
        }
    });
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() == "fiskheroes:controlled_flight") {
        return entity.getData("fiskheroes:dyn/steeled");
    }
    return true;
}

function isKeyBindEnabled(entity, keyBind) {
    return keyBind != "BINARY_MODE" ? !(entity.isSprinting() && entity.getData("fiskheroes:flying")) : true;
}

function getTierOverride(entity) {
    return entity.getData("fiskheroes:dyn/steeled") ? 9 : 10;
}

function canAim(entity) {
    return entity.getHeldItem().isEmpty() && entity.getData("fiskheroes:beam_charge") == 0;
}