function init(hero) {
    hero.setName("Crystalface");
    hero.setTier(7);

    hero.setHelmet("item.superhero_armor.piece.head");
    hero.addPrimaryEquipment("fiskheroes:captain_americas_shield{Electromagnetic:1,display:{Name:\"Crystal Shield\"}}", true);

    hero.addPowers("smp:petrosapien_physiology");
    hero.addAttribute("PUNCH_DAMAGE", 8.5, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);
    hero.addAttribute("JUMP_HEIGHT", 0.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 8.0, 0);

    hero.addKeyBind("SHIELD_THROW", "key.shieldThrow", 1);
    hero.addKeyBind("CRYSTAL_TRANSFORMATION", "Crystal Transformation", 5);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setTierOverride(getTierOverride);
    hero.setHasPermission(hasPermission);

    hero.setAttributeProfile(entity => entity.getData("smp:dyn/crystal") ? null : "INACTIVE");
    hero.addAttributeProfile("INACTIVE", profile => {
        profile.revokeAugments();
    });
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() != "fiskheroes:transformation") {
        return entity.getData("smp:dyn/crystal");
    }
    return true;
}

function isKeyBindEnabled(entity, keyBind) {
    if (keyBind != "CRYSTAL_TRANSFORMATION" && !entity.getData("smp:dyn/crystal")) {
        return false;
    }
    return keyBind != "SHIELD_THROW" || entity.getHeldItem().name() == "fiskheroes:captain_americas_shield";
}

function getTierOverride(entity) {
    return entity.getData("smp:dyn/crystal") ? 7 : 0;
}

function hasPermission(entity, permission) {
    if (entity.getData("smp:dyn/crystal")) {
        return permission == "USE_SHIELD";
    }
    return false;
}