extend("fiskheroes:hero_basic");
loadTextures({
    "null": "smp:null",
    "crystalface": "smp:crystalface",
    "lights": "smp:crystalface_lights",
    "shield": "smp:crystalface_shield",
    "shield_lights": "smp:crystalface_shield_lights",
    "board": "smp:crystalface_board",
    "board_lights": "smp:crystalface_board_lights",
    "board_summon": "smp:crystalface_board_summon"
});

var utils = implement("fiskheroes:external/utils");

var glow;

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        return !entity.is("DISPLAY") ? "null" : "crystalface";
    });
    renderer.setLights((entity, renderLayer) => {
        return !entity.is("DISPLAY") ? "null" : "lights";
    });

    renderer.showModel("HELMET", "head", "headwear", "body", "rightArm", "leftArm", "rightLeg", "leftLeg");
    renderer.fixHatLayer("HELMET");
}

function initEffects(renderer) {
    crystalface = renderer.createEffect("fiskheroes:overlay");
    crystalface.texture.set("crystalface", "lights");

    utils.bindParticles(renderer, "smp:crystalface_transform");

    glow = renderer.createEffect("fiskheroes:glowerlay");
    glow.includeEffects(crystalface);
    glow.color.set(0x01FF70);

    utils.bindParticles(renderer, "fiskheroes:harbinger_glow");

    var livery = renderer.bindProperty("fiskheroes:livery");
    livery.texture.set("shield", "shield_lights");
    livery.weaponType = "SHIELD";

    board = renderer.createEffect("fiskheroes:model");
    board.setModel(utils.createModel(renderer, "smp:crystalface_board", "board", "board_lights"));
    board.anchor.set("body");

    board_summon = renderer.createEffect("fiskheroes:model");
    board_summon.setModel(utils.createModel(renderer, "smp:crystalface_board", null, "board_summon"));
    board_summon.anchor.set("body");
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);

    addAnimation(renderer, "crystalface.FLIGHT", "smp:flight/idle/crystalface").setData((entity, data) => {
        data.load(entity.getInterpolatedData("fiskheroes:flight_timer"));
    }).priority = -5;
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (entity.getData("smp:dyn/crystal_timer") >= 0.5) {
        crystalface.render();
    }

    if (entity.getData("fiskheroes:flight_timer") > 0) {
        var f = Math.min(entity.getInterpolatedData("fiskheroes:flight_timer") * 2, 1);
        board_summon.opacity = Math.sin(Math.PI * entity.getInterpolatedData("fiskheroes:flight_timer"));
        board_summon.setRotation(0, 90 * f, 0);
        board_summon.setScale(f * 1.01, 1.01, f * 1.01);
        board_summon.setOffset(0, 1.2625 - 3.2 * f, 0);
        board_summon.render();

        board.opacity = entity.getData("fiskheroes:flight_timer") >= 0.5 ? 1 : 0;
        board.setRotation(0, 90 * f, 0);
        board.setScale(f, 1, f);
        board.setOffset(0, 1.5 - 3.2 * f, 0);
        board.render();
    }

    glow.opacity = Math.sin(Math.PI * entity.getInterpolatedData("smp:dyn/crystal_timer"));
    glow.render();
}