extend("fiskheroes:hero_basic"),
loadTextures({
    "layer1": "smp:shadowbolt_layer1",
    "layer2": "smp:shadowbolt_layer2"
});

var utils = implement("fiskheroes:external/utils");
var speedster = implement("fiskheroes:external/speedster_utils");

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        if (renderLayer == "HELMET" && (entity.isDisplayStand() || entity.isBookPlayer() ? entity.getData("fiskheroes:mask_open") : entity.getData("fiskheroes:mask_open_timer2") > 0.35)) {
            return "layer2";
        }
        return renderLayer == "LEGGINGS" ? "layer2" : "layer1";
    });
}

function initEffects(renderer) {
    var trail = renderer.bindProperty("fiskheroes:trail");
    trail.setTrail(renderer.createResource("TRAIL", "smp:lightning_burst")).setCondition(entity => entity.getData("fiskheroes:speeding"));

    utils.bindBeam(renderer, "fiskheroes:energy_manipulation", "fiskheroes:lightning_cast", "rightArm", 0xE0FFFF, [
        { "firstPerson": [-8.0, 4.5, -10.0], "offset": [-0.5, 9.0, 0.0], "size": [0.75, 0.75] }
    ]);

    speedster.init(renderer);

    lightning = utils.createLines(renderer, ("BEAM_RENDERER", "smp:lightning_sword"), 0xE0FFFF, [
        {"start": [0, 0, 4], "end": [0, 0, -18], "size": [5.0, 5.0]}]);
    
    lightning.anchor.set("rightArm");
    lightning.setOffset(1.0, 9.0, 2.0);
    lightning.setScale(1.0);
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    addAnimation(renderer, "flash.MASK", "fiskheroes:remove_cowl")
        .setData((entity, data) => {
            var f = entity.getInterpolatedData("fiskheroes:mask_open_timer2");
            data.load(f < 1 ? f : 0);
        });
}

function render(entity, renderLayer, isFirstPersonArm) {
    lightning.render();
    lightning.opacity = entity.getInterpolatedData("fiskheroes:blade_timer");
}