extend("fiskheroes:hero_basic");
loadTextures({
    "suit": "smp:thundercrash",
    "null": "smp:null"
});

var utils = implement("fiskheroes:external/utils");

function init(renderer) {
    parent.init(renderer);
    renderer.setTexture((entity, renderLayer) => {
        return "null";
    });

    renderer.showModel("CHESTPLATE", "head", "headwear", "body", "rightArm", "leftArm", "rightLeg", "leftLeg");
    renderer.fixHatLayer("CHESTPLATE");
}

function initEffects(renderer) {
    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:thunderclap", "body", 0x0059FF, [
        { "firstPerson": [0.0, 6.0, 0.0], "offset": [0.0, -5.0, -10.0], "size": [1.5, 1.5] }
    ]);

    transform = renderer.createEffect("fiskheroes:overlay");
    transform.texture.set("suit");

    var trail = renderer.bindProperty("fiskheroes:trail");
    trail.setTrail(renderer.createResource("TRAIL", "smp:lightning_thundercrash")).setCondition(entity => entity.getData("smp:dyn/gamma"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);

    addAnimation(renderer, "thundercrash.THUNDERCLAP", "smp:thunderclap").setData((entity, data) => {
        data.load(entity.getInterpolatedData("fiskheroes:beam_charge"));
    });

    addAnimation(renderer, "basic.PUNCH", "smp:hulk_punch").setData((entity, data) => {
        data.load(entity.getData("smp:dyn/gamma") ? entity.getPunchTimerInterpolated() : 0);
    });

    addAnimation(renderer, "thundercrash.TRANSFORM", "smp:gamma_transform").setData((entity, data) => {
        data.load(entity.getData("smp:dyn/gamma_timer"));
    });
}

function render(entity, renderLayer, isFirstPersonArm) {
    transform.opacity = entity.getInterpolatedData("smp:dyn/gamma_timer");
    transform.render();
}
